   '***********************************************************************'
   ' ukazatel score
   '                                                                       '
   ' v 1.0 (z 14.12.2010)                                                 '
   '                                                                       '
   ' Autor : Pavel Jank                                                   '
   ' www.paja-trb.cz                                                  '
   ' paja@paja-trb.cz                                                    '
   '                                                                       '
   '***********************************************************************'

'$sim                                                        '!!!Odstranit pi programovn - zrychlen simulace

$regfile = "m8def.dat"                                      'Soubor s deklaracemi
$crystal = 8000000                                          'Kmitoet osciltoru v Hz
$hwstack = 32
$swstack = 8
$framesize = 16

Dim A As Byte

Declare Sub Preved()
Declare Sub Cti_tlacitka()
Declare Sub Na_displej_m()
Declare Sub Na_displej_v()
Declare Sub Na_displej_paja()

Config Kbd = Portd                                          'klvesnice na portu D (3x3 tal)
Dim Tlacitka As Byte
Dim Cetlose As Bit
Cetlose = 0

Dim Score1a As Byte , Sco1a As Byte , Score1 As Byte
Dim Score1b As Byte , Sco1b As Byte
Dim Score2a As Byte , Sco2a As Byte , Score2 As Byte
Dim Score2b As Byte , Sco2b As Byte
Dim Score3a As Byte , Sco3a As Byte , Score3 As Byte
Dim Score3b As Byte , Sco3b As Byte
Dim Score4a As Byte , Sco4a As Byte , Score4 As Byte
Dim Score4b As Byte , Sco4b As Byte

Score1a = 0                                                 'desitky pro odeslani na dsiplej
Score1b = 0                                                 'jednotky pro odeslani na dsiplej
Score2a = 0
Score2b = 0
Score3a = 0
Score3b = 0
Score4a = 0
Score4b = 0
Sco1a = 0                                                   'desitky
Sco1b = 0                                                   'jednotky
Sco2a = 0
Sco2b = 0
Sco3a = 0
Sco3b = 0
Sco4a = 0
Sco4b = 0
Score1 = 0                                                  'dvouciferne cislo Score1
Score2 = 0
Score3 = 0
Score4 = 0

Data_m Alias Portc.3
Clk_m Alias Portc.5
Strobe_m Alias Portc.4

Data_v Alias Portb.2
Clk_v Alias Portb.0
Strobe_v Alias Portb.1

Const Shift_delay = 20                                      ' shift delay in microseconds

'pocatecni nastaveni posuvnych reg. 74HC595
Set Clk_m
Reset Data_m
Reset Strobe_m

Clk4017 Alias Portc.2
Zapni4017 Alias Portc.1
Dim Odpocet As Byte
Odpocet = 0
Zapni4017 = 0
Clk4017 = 0

Config Portc = Output
Config Portb = Output
Config Portd.3 = Output

Enable Interrupts                                           'povol preruseni
'nastaveni preruseni kazdou 1s, pro odpotu
Config Timer1 = Timer , Prescale = 256                      '1krok tae = 8 (MHz) / 256 (peddli) = 31250 Hz
On Ovf1 Odpocet10s                                          'obsluha peruen od Timeru1
Enable Timer1                                               'povol asova 1
Tcnt1h = 133                                                't od 0 do max. 65536 "16bit" -> 65536 - 31250 = 34286 = 133*256+238
Tcnt1l = 238

Gosub Na_displej_paja                                       'prvotni zobrazeni po zapnuti "- PAJA -"

Gosub Preved                                                'preved nactene hodnoty na jednociferne (po zapnuti 0 0 0 0)
Gosub Na_displej_m                                          'posli data na maly displej
Gosub Na_displej_v                                          'posli data na velky displej

'============================== hlavni program =================================

Do

Gosub Cti_tlacitka

   'osetreni, aby se nemuselo porad znova vysilad data na displeje, kdyz se nezmenila zadna hodnota tlacitek
   If Cetlose = 1 Then                                      'kdyz bylo stisknuto nejake tlac, tak
      Gosub Preved                                          'preved nactene hodnoty na jednociferne (a podle potreby odstran nulu v desitkach)
      Gosub Na_displej_m                                    'posli data na maly displej
      Gosub Na_displej_v                                    'posli data na velky displej
   End If

Loop

End

'============================ / hlavni program =================================


''''''''''''''''''''''''''''''''Peti tlaitka ''''''''''''''''''''''''''''''''
Sub Cti_tlacitka():

Cetlose = 1
Tlacitka = Getkbd()                                         'precti stav na "klavesnici"
Waitms 50                                                   'pockej 50ms - ochrana proti zakmitum

Select Case Tlacitka                                        'vyber podle nactene hodnoty pozadovanou akci
   Case 16 : Cetlose = 0                                    'pokud neni stisknuto zadne tlac (tlacitka vraci 16), tak vynuluj reg.cetlose
   Case 6 : If Score1 > 0 Then                              'stisknuto 1- a pokud je Score1 vt jak nula,
             Decr Score1                                    'tak jej dekrementuj - zmen o jednu
             End If

   Case 10 : If Score1 < 99 Then                            'stisktnuto 1+ a pokud je Score1 men ne 99,
             Incr Score1                                    'tak jej Inkrementuj - zvt o jednu
             End If

   Case 14 : If Score2 > 0 Then
             Decr Score2
             End If
   Case 5 : If Score2 < 99 Then
             Incr Score2
             End If

   Case 9 : If Score3 > 0 Then
             Decr Score3
             End If
   Case 13 : If Score3 < 99 Then
             Incr Score3
             End If

   Case 4 : If Score4 > 0 Then
             Decr Score4
             End If

   Case 8 : If Score4 < 99 Then
             Incr Score4
             End If

   Case 12 : Reset Zapni4017                                'tlatko odpotu - spus Timer1, kter kadou sekundu vyle impulz na odpoet ...
             Waitms 10
             Odpocet = 0
             Start Timer1
             Set Zapni4017
             Waitms 10
             Set Clk4017
             Waitms 10
             Reset Clk4017
End Select

Waitms 100                                                  'ochrana proti zkmitm

End Sub

'---------------------------- obsluha peruen kadou 1s -----------------------------------
Odpocet10s:
   Tcnt1h = 133                                             'znovunastav registry asovae1
   Tcnt1l = 238

   Incr Odpocet                                             'inkrementuj - piti 1
   If Odpocet < 10 Then                                     'kdy nen 10x provedeno tak poli impulz na odpoet
      Set Clk4017
      Waitms 10
      Reset Clk4017
   Else
      Odpocet = 0
      Stop Timer1                                           'zastav asova
      Wait 1                                                ' po dokonen odpotu pokej 1s (aby zstala svtit LEDka 10 a pskat piezo)
      Reset Zapni4017                                       'vypni napjen odpotu
   End If

Return


'''''''''''''''''''''''''''''''''''''' Obsluha pevodu '''''''''''''''''''''''''''''''''''''''''''''''
'rozdeli dvouciferne cislo ve Score* na dve jednociferna do Sco*a a Sco*b
Sub Preved()

   Sco1b = Makebcd(score1)                                  'prevod na BCD
   Sco1a = Sco1b
   Sco1b = Sco1b And &B0000_1111                            'odmaskuj "desitky"
   Shift Sco1a , Right , 4                                  'posun obsah Sco1a o 4 pozice doprava => vycleni jednociferne cislo desitek
      If Sco1a = 0 Then                                     'kdyz je v desitkach 0, tak ji nezobrazuj
      Sco1a = 10                                            'nezobrazit odpovida pozice 10 v tabulce dat pro pos. reg
      End If

   Sco2b = Makebcd(score2)
   Sco2a = Sco2b
   Sco2b = Sco2b And &B0000_1111
   Shift Sco2a , Right , 4
      If Sco2a = 0 Then
      Sco2a = 10
      End If

   Sco3b = Makebcd(score3)
   Sco3a = Sco3b
   Sco3b = Sco3b And &B0000_1111
   Shift Sco3a , Right , 4
      If Sco3a = 0 Then
      Sco3a = 10
      End If

   Sco4b = Makebcd(score4)
   Sco4a = Sco4b
   Sco4b = Sco4b And &B0000_1111
   Shift Sco4a , Right , 4
      If Sco4a = 0 Then
      Sco4a = 10
      End If

End Sub


'''''''''''''''''''''''''''''''' Obsluha pekodovn a odesln na displej ''''''''''''''''''''''''''''''''

'prevedenou hodnotu z tabulky posli seriove na displeje - maly
Sub Na_displej_m()

Score1b = Lookup(sco1b , Tabulka_maly)                      'podivej se do tabulky, preved a uloz do Score1b
Score1a = Lookup(sco1a , Tabulka_maly)
Score2b = Lookup(sco2b , Tabulka_maly)
Score2a = Lookup(sco2a , Tabulka_maly)
Score3b = Lookup(sco3b , Tabulka_maly)
Score3a = Lookup(sco3a , Tabulka_maly)
Score4b = Lookup(sco4b , Tabulka_maly)
Score4a = Lookup(sco4a , Tabulka_maly)

'seriove odeslani prevdenych dat na displeje
Shiftout Data_m , Clk_m , Score4b , 0 , 8 , Shift_delay
Shiftout Data_m , Clk_m , Score4a , 0 , 8 , Shift_delay
Shiftout Data_m , Clk_m , Score3b , 0 , 8 , Shift_delay
Shiftout Data_m , Clk_m , Score3a , 0 , 8 , Shift_delay
Shiftout Data_m , Clk_m , Score2b , 0 , 8 , Shift_delay
Shiftout Data_m , Clk_m , Score2a , 0 , 8 , Shift_delay
Shiftout Data_m , Clk_m , Score1b , 0 , 8 , Shift_delay
Shiftout Data_m , Clk_m , Score1a , 0 , 8 , Shift_delay

Waitms 1                                                    'strobe - prenes data na displej
Set Strobe_m
Waitms 1
Reset Strobe_m

End Sub

'''''''''''''''''''''''''''''''' Obsluha pekodovn a odesln na displej ''''''''''''''''''''''''''''''''

'prevedenou hodnotu z tabulky posli seriove na displeje - velky
Sub Na_displej_v()

Score1b = Lookup(sco1b , Tabulka_velky)                     'podivej se do tabulky, preved a uloz do Score1b
Score1a = Lookup(sco1a , Tabulka_velky)
Score2b = Lookup(sco2b , Tabulka_velky)
Score2a = Lookup(sco2a , Tabulka_velky)
Score3b = Lookup(sco3b , Tabulka_velky)
Score3a = Lookup(sco3a , Tabulka_velky)
Score4b = Lookup(sco4b , Tabulka_velky)
Score4a = Lookup(sco4a , Tabulka_velky)

'seriove odeslani prevdenych dat na displeje
Shiftout Data_v , Clk_v , Score1b , 0 , 8 , Shift_delay
Shiftout Data_v , Clk_v , Score1a , 0 , 8 , Shift_delay
Shiftout Data_v , Clk_v , Score2b , 0 , 8 , Shift_delay
Shiftout Data_v , Clk_v , Score2a , 0 , 8 , Shift_delay
Shiftout Data_v , Clk_v , Score3b , 0 , 8 , Shift_delay
Shiftout Data_v , Clk_v , Score3a , 0 , 8 , Shift_delay
Shiftout Data_v , Clk_v , Score4b , 0 , 8 , Shift_delay
Shiftout Data_v , Clk_v , Score4a , 0 , 8 , Shift_delay

Waitms 1                                                    'strobe - prenes data na displej
Set Strobe_v
Waitms 1
Reset Strobe_v

End Sub

'--------------------------------------------------------------------------------------------------------

Sub Na_displej_paja()

' - PAJA -
Score1b = &B11111111
Score1a = &B11101111
Score2b = &B00001001
Score2a = &B00101001
Score3b = &B00001001
Score3a = &B01010101
Score4b = &B11101111
Score4a = &B11111111

Shiftout Data_m , Clk_m , Score4b , 0 , 8 , Shift_delay : Waitms 1 : Set Strobe_m : Waitms 100 : Reset Strobe_m
Shiftout Data_m , Clk_m , Score4a , 0 , 8 , Shift_delay : Waitms 1 : Set Strobe_m : Waitms 100 : Reset Strobe_m
Shiftout Data_m , Clk_m , Score3b , 0 , 8 , Shift_delay : Waitms 1 : Set Strobe_m : Waitms 100 : Reset Strobe_m
Shiftout Data_m , Clk_m , Score3a , 0 , 8 , Shift_delay : Waitms 1 : Set Strobe_m : Waitms 100 : Reset Strobe_m
Shiftout Data_m , Clk_m , Score2b , 0 , 8 , Shift_delay : Waitms 1 : Set Strobe_m : Waitms 100 : Reset Strobe_m
Shiftout Data_m , Clk_m , Score2a , 0 , 8 , Shift_delay : Waitms 1 : Set Strobe_m : Waitms 100 : Reset Strobe_m
Shiftout Data_m , Clk_m , Score1b , 0 , 8 , Shift_delay : Waitms 1 : Set Strobe_m : Waitms 100 : Reset Strobe_m
Shiftout Data_m , Clk_m , Score1a , 0 , 8 , Shift_delay : Waitms 1 : Set Strobe_m : Waitms 100 : Reset Strobe_m

Waitms 1
Set Strobe_m
Waitms 1
Reset Strobe_m

Waitms 5

' - PAJA -
Score1b = &B00000000
Score1a = &B00000001
Score2b = &B01011111
Score2a = &B01001111
Score3b = &B01011111
Score3a = &B01111000
Score4b = &B00000001
Score4a = &B00000000

Shiftout Data_v , Clk_v , Score4b , 0 , 8 , Shift_delay
Shiftout Data_v , Clk_v , Score4a , 0 , 8 , Shift_delay
Shiftout Data_v , Clk_v , Score3b , 0 , 8 , Shift_delay
Shiftout Data_v , Clk_v , Score3a , 0 , 8 , Shift_delay
Shiftout Data_v , Clk_v , Score2b , 0 , 8 , Shift_delay
Shiftout Data_v , Clk_v , Score2a , 0 , 8 , Shift_delay
Shiftout Data_v , Clk_v , Score1b , 0 , 8 , Shift_delay
Shiftout Data_v , Clk_v , Score1a , 0 , 8 , Shift_delay

Waitms 1                                                    'strobe - prenes data na displej
Set Strobe_v
Waitms 1
Reset Strobe_v

Wait 1

End Sub


' ==================================== Dekodavaci tabulky ==========================================================================='
Tabulka_maly:
Data &B00010001 , &B01011111 , &B00100101 , &B00000111 , &B01001011 , &B10000011 , &B10000001 , &B00011111 , &B00000001 , &B00000011 , &B11111111
'     0              1           2              3           4           5           6              7           8           9             10 - zhasnuto

Tabulka_velky:
Data &B01111110 , &B00011000 , &B01101101 , &B00111101 , &B00011011 , &B00110111 , &B01110111 , &B00011100 , &B01111111 , &B00111111 , &B00000000
'     0              1           2              3           4           5           6              7           8           9             10 - zhasnuto
'    &B1xxx xxxx - desetinn teka

'prirazeni tlacitek...
'1-      6
'1+      10
'2-      14
'2+      5
'3-      9
'3+      13
'4-      4
'4+      8
'10s     12
'jinak 16 a odchod